#include <NewSoftSerial.h>

NewSoftSerial mySerial(7,8);

#define rs485com 9
#define INKeyA A0
#define INKeyB A1
#define INKeyC A2
#define DKeyA 11
#define DKeyB 12
#define DKeyC 13
#define DKeyIN 10
#define clockPin 6
#define latchPin 5
#define dataPin 4
#define PCTimeERR 90          //1分半鐘
#define Power66OffTime 600    //10分鐘
#define PowerOffTime 5        //5秒鐘
#define NoKeyHouse            //不用KeyHouse的設定
#define PrivacyCleaning       //偵測點用於打掃物擾的設定  不用偵測點用於一氧化碳防盜的設定

byte PCDATA[24] = {0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0,
                   0x22,0};
byte pcdata[24];                    

byte RoomDATA[24] ={0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0,
                    0,0};                          
byte INDATA[7] = {0,0,0,0,0,0,0};
byte OUTDATA[6] = {0,0,0,0,0,0};
byte indata[6] = {0,0,0,0,0,0};
int RoomTime[12];
int  Rs485SP = 0, incomCS = 0;
word TIMEBF = 0,ROOM = 0;
byte ID = 0,SPBF = 0;
/*
SPBF0      IN kye
SPBF1      Out Relay
SPBF2      Time 1s
SPBF3      Pc urtl ree
SPBF4
SPBF5
SPBF6
SPBF7
TIMEBF0    Room1 POWER DELAY ON/OFF
TIMEBF1    Room2 POWER DELAY ON/OFF
TIMEBF2    Room3 POWER DELAY ON/OFF
TIMEBF3    Room4 POWER DELAY ON/OFF
TIMEBF4    Room5 POWER DELAY ON/OFF
TIMEBF5    Room6 POWER DELAY ON/OFF
TIMEBF6    Room7 POWER DELAY ON/OFF
TIMEBF7    Room8 POWER DELAY ON/OFF
TIMEBF8    Room9 POWER DELAY ON/OFF
TIMEBF9    Room10 POWER DELAY ON/OFF
TIMEBF10   Room11 POWER DELAY ON/OFF
TIMEBF11   Room12 POWER DELAY ON/OFF
TIMEBF12
TIMEBF13
TIMEBF14
TIMEBF15
ROOM0      Room1 Process ON/OFF
ROOM1      Room2 Process ON/OFF
ROOM2      Room3 Process ON/OFF
ROOM3      Room4 Process ON/OFF
ROOM4      Room5 Process ON/OFF
ROOM5      Room6 Process ON/OFF
ROOM6      Room7 Process ON/OFF
ROOM7      Room8 Process ON/OFF
ROOM8      Room9 Process ON/OFF
ROOM9      Room10 Process ON/OFF
ROOM10     Room11 Process ON/OFF
ROOM11     Room12 Process ON/OFF
ROOM12
ROOM13
ROOM14
ROOM15
*/
int count = 0, innext = 0, PCcomERR = 0, Rs485ERR = 0;  
/* 
 * 将定时器中断设为2ms 
 */  
void init_time()  
{  
//    TCCR2A |= (1 <<WGM21) | (1 << WGM20);  
    TCCR2A = 0;
//    TCCR2B |= (1 << CS22 );  //by clk/64  
//    TCCR2B &= ~((1 <<CS21) | (1 <<CS20));  //by clk/64
    TCCR2B |= ((1 << CS22 ) | (1 <<CS20));  //by clk/128  
    TCCR2B &= ~(1 <<CS21);  //by clk/128
//    TCCR2B &= ~((1 << WGM21 ) | (1 << WGM20));  
    ASSR |= ( 1 << AS2 );  
    TIMSK2 |= ( 1 << TOIE2 ) | ( 0 << OCIE2B );  
    TCNT2 = 6;  
    sei();  
}  
/* *（CPU頻率）16M/128（預分頻值）=125000赫茲=8US。
   *（所需時間1ms）/8US=125。
   * MAX（UINT8(255)）+1 - 125 =131;  */
ISR(TIMER2_OVF_vect)
{  
    TCNT2 = 6;        
    count++;
    Rs485ERR++;  
    if ((Rs485ERR % 15) == 0){
        Rs485SP = 0;
        Rs485ERR = 0;
    }
    if ((count % 20) == 0)
        SPBF |= 0x01;
    if ((count % 100) == 0)
        SPBF |= 0x02;    
    if (count == 500)
    {
        count = 0;
        SPBF |= 0x04;
        PCcomERR++;
        if (PCcomERR == PCTimeERR)
            SPBF |= 0x08;
    }  
      
}  

void setup() {
Serial.begin(115200);
mySerial.begin(9600);
pinMode(INKeyA,OUTPUT);
pinMode(INKeyB,OUTPUT);
pinMode(INKeyC,OUTPUT);
pinMode(DKeyA,OUTPUT);
pinMode(DKeyB,OUTPUT);
pinMode(DKeyC,OUTPUT);
pinMode(DKeyIN,INPUT);
pinMode(latchPin, OUTPUT);
pinMode(clockPin, OUTPUT);
pinMode(dataPin, OUTPUT);
pinMode(rs485com,OUTPUT);
digitalWrite(rs485com, LOW);
init_time();  
delay(500); 
}

byte bin[] = {
0,1,10,11,100,101,110,111};

void readKeyboard() {          //作輸入點偵測
    int row,col,v,d;
    byte r0,r1,r2;
    for(int i=0;i<7;i++) {
        d = 0;
        // address Y
        col = bin[i];
        r0 = col & 1;
        r1 = (col>>1) & 1;
        r2 = (col>>2) & 1;
        digitalWrite(DKeyA, r0);
        digitalWrite(DKeyB, r1);
        digitalWrite(DKeyC, r2);
        delayMicroseconds(20);
        for(int j=0;j<8;j++) {
            // address X
            row = bin[j];
            r0 = row & 1;
            r1 = (row>>1) & 1;
            r2 = (row>>2) & 1;
            digitalWrite(INKeyA, r0);
            digitalWrite(INKeyB, r1);
            digitalWrite(INKeyC, r2);
            // Read the actual Value
            delayMicroseconds(20);
            v = digitalRead(DKeyIN);
            if (v == LOW)
                d = (d >> 1) & 0x7F; 
            else
                d = (d >> 1) | 0x80;
        }            
            INDATA[i] = d ^ 0xFF;        
    }
}

void loop()
{
    if((SPBF & 0x01) == 1)              //讀取外部輸入
    {       
        SPBF &= 0xFE;
        int inkey = 0;
        readKeyboard();
        for (int i = 0; i < 6; i++)
        {
            if (INDATA[i + 1] != indata[i])
                inkey = 1;
        }
        ID = INDATA[0];
        if (inkey == 0)
            innext = 0;
        else
            innext++;  
    }       
    if ((SPBF & 0x02) == 0x02)          //作輸出點資料傳輸
    {
        SPBF &= 0xFD;
        digitalWrite(latchPin, LOW);
        for (int j = 5; j >= 0; j--)
        {
            shiftOut(dataPin, clockPin, MSBFIRST,(OUTDATA[j] ^ 0x66));   
        }    
        digitalWrite(latchPin, HIGH);   
/*        for (int j = 5; j >= 0; j--)
        {
            Serial.println(OUTDATA[j],BIN);
        }    */
    }
    if (innext > 10)                    //處理輸入點動作
    {
//        Serial.println("INkey ok");
//        ROOM = 0;
        for (int i = 0; i < 12; i++)
        {
            if ((i % 2) == 0)
            {
                if ((INDATA[(i / 2) + 1] & 0x0F) != (indata[i / 2] & 0x0F))
                    ROOM |= (0x0001 << i); 
            }
            else
            {
                if ((INDATA[(i / 2) + 1] & 0xF0) != (indata[i / 2] & 0xF0))
                    ROOM |= (0x0001 << i); 
            }
        }
        Process();
        for (int i = 0; i < 6; i++)
        {
            indata[i] = INDATA[i + 1];
        }
        //RoomToPC();
//        Serial.println(RoomDATA[0],HEX);
  //      Serial.println(indata[0],HEX);
    //    Serial.println(OUTDATA[0],HEX);
        innext = 0;
    }  
    if ((SPBF & 0x04) == 0x04)           //作房間二次電時間處理
    {
        SPBF &= 0xFB;
        for (int i = 0; i < 12; i++)
        {
            RoomTime[i]--;
            if (RoomTime[i] == 0)
            {
                RoomTime[i] = 1;
                word time = 0x0001;
                time = TIMEBF & (time << i);
                if (time > 0)
                {
                    //TIMEBF &= (0xFFFE << i);              //做2次電關
                    if ((i % 2) == 0)
                        OUTDATA[i / 2] &= 0xFD;   
                    else
                        OUTDATA[i / 2] &= 0xDF;   
//                   Serial.println((i / 2),HEX);     
                 }  
            }
        }
        RoomToPC();
    }
    if ((SPBF & 0x08) == 0x08)          //PC通訊斷線
    {
        SPBF &= 0xF7;
        for(int i = 0; i < 12; i++)
        {
            PCDATA[i * 2] = 0x22;
        }
        ROOM = 0x0FFF;
        Process();
    }
    if (mySerial.available() > 0)         //偵測RS-485是否有資料進來
    {    
        RS485IN();
    }
}
void Process(void)            //處理房間動作
{
    for  (int x = 0; x < 12; x++)
    {
        if ((ROOM & (0x0001 << x)) > 0)
        {
//            Serial.println("Procrss OK");
//            Serial.println(x,HEX);
            ROOM &= (0xFFFE << x);
            if ((x % 2) == 0)
            {
                switch (PCDATA[x * 2])
                {
                case 0x11:
                    OUTDATA[x / 2] &= 0xF1;
                    break;
                case 0x66:
                    switch (INDATA[(x / 2) + 1] & 0x03)
                    {
#ifdef NoKeyHouse                      
                    case 0:
                        OUTDATA[x / 2] &= 0xFB;
                        OUTDATA[x / 2] |= 0x04;
                        RoomTime[x] = PowerOffTime;
                        TIMEBF |= (0x0001 << x);
                        break;
                    case 2:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x06;
                        RoomTime[x] = Power66OffTime;
                        TIMEBF |= (0x0001 << x);
                        break;
#else      
                    case 0:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x04;
                        break;
                    case 1:
                        if ((indata[x / 2] & 0x01) == 1)
                        {
                            OUTDATA[x / 2] &= 0xFB;
                            OUTDATA[x / 2] |= 0x04;
                            RoomTime[x] = PowerOffTime;
                            TIMEBF |= (0x0001 << x);
                        }
                        else
                        {
                            OUTDATA[x / 2] &= 0xFD;
                            OUTDATA[x / 2] |= 0x08;
                        }
                        break;
                    case 2:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x04;
                        break;
                    case 3:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x06;
                        RoomTime[x] = Power66OffTime;
                        TIMEBF |= (0x0001 << x);
                        break;
#endif
                    }
                    break;
                default: 
                    switch (INDATA[(x / 2) + 1] & 0x03)
                    {
#ifdef NoKeyHouse                      
                    case 0:
                        OUTDATA[x / 2] &= 0xFB;
                        RoomTime[x] = PowerOffTime;
                        TIMEBF = TIMEBF | (0x0001 << x);
                        break;
                    case 2:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x06;
                        TIMEBF = TIMEBF & (0xFFFE << x);
                        break;
#else                   
                    case 0:
                        OUTDATA[x / 2] &= 0xF1;
                        break;
                    case 1:
                        if ((indata[x / 2] & 0x01) == 1)
                        {
                            OUTDATA[x / 2] &= 0xFB;
                            OUTDATA[x / 2] |= 0x08;
                            RoomTime[x] = PowerOffTime;
                            TIMEBF |= (0x0001 << x);
                        }
                        else
                        {
                            OUTDATA[x / 2] &= 0xFD;
                            OUTDATA[x / 2] |= 0x08;
                        }
                        break;
                    case 2:
                        OUTDATA[x / 2] &= 0xF1;
                        break;
                    case 3:
                        OUTDATA[x / 2] &= 0xF1;
                        OUTDATA[x / 2] |= 0x06;
                        TIMEBF = TIMEBF & (0xFFFE << x);
                        break;
#endif
                    }
                    break;
                }
            }
            else
            {
                switch (PCDATA[x * 2])
                {
                case 0x11:
                    OUTDATA[x / 2] &= 0x1F;
                    break;
                case 0x66:
                    switch (INDATA[(x / 2) + 1] & 0x30)
                    {
#ifdef NoKeyHouse                       
                    case 0x00:
                        OUTDATA[x / 2] &= 0xBF;
                        OUTDATA[x / 2] |= 0x40;
                        RoomTime[x] = PowerOffTime;
                        TIMEBF = TIMEBF | (0x0001 << x);
                        break;
                    case 0x20:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x60;
                        RoomTime[x] = Power66OffTime;
                        TIMEBF = TIMEBF | (0x0001 << x);
                        break;
#else           
                    case 0x00:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x40;
                        break;
                    case 0x10:
                        if ((indata[x / 2] & 0x10) == 0x10)
                        {
                            OUTDATA[x / 2] &= 0xBF;
                            OUTDATA[x / 2] |= 0x40;
                            RoomTime[x] = PowerOffTime;
                            TIMEBF = TIMEBF | (0x0001 << x);
                        }
                        else
                        {
                            OUTDATA[x / 2] &= 0xDF;
                            OUTDATA[x / 2] |= 0x80;
                        }
                        break;
                    case 0x20:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x40;
                        break;
                    case 0x30:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x60;
                        RoomTime[x] = Power66OffTime;
                        TIMEBF = TIMEBF | (0x0001 << x);
                        break;
#endif
                    }
                    break;
                default: 
                    switch (INDATA[(x / 2) + 1] & 0x30)
                    {
#ifdef NoKeyHouse                       
                    case 0x00:
                        OUTDATA[x / 2] &= 0xBF;
                        RoomTime[x] = PowerOffTime;
                        TIMEBF = TIMEBF | (0x0001 << x);
                        break;
                    case 0x20:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x60;
                        TIMEBF = TIMEBF & (0xFFFE << x);
                        break;
#else    
                    case 0x00:
                        OUTDATA[x / 2] &= 0x1F;
                        break;
                    case 0x10:
                        if ((indata[x / 2] & 0x10) == 0x10)
                        {
                            OUTDATA[x / 2] &= 0xBF;
                            OUTDATA[x / 2] |= 0x80;
                            RoomTime[x] = PowerOffTime;
                            TIMEBF = TIMEBF | (0x0001 << x);
                        }
                        else
                        {
                            OUTDATA[x / 2] &= 0xDF;
                            OUTDATA[x / 2] |= 0x80;
                        }
                        break;
                    case 0x20:
                        OUTDATA[x / 2] &= 0x1F;
                        break;
                    case 0x30:
                        OUTDATA[x / 2] &= 0x1F;
                        OUTDATA[x / 2] |= 0x60;
                        TIMEBF = TIMEBF & (0xFFFE << x);
                        break;
#endif
                    }
                    break;
                }
            }
        }
    }
//    ROOM = 0;
}
void RoomToPC(void)        //把房間資料轉換為PC格式
{
    for(int i = 0; i < 6; i++)
    {
#ifdef NoKeyHouse 
        RoomDATA[i * 4] = indata[i] & 0x02;                                                 //kb
        RoomDATA[i * 4] |= ((RoomDATA[i * 4] << 1) & 0x04);                                 //kh
        RoomDATA[i * 4] |= ((OUTDATA[i] >> 1) & 0x01) | ((OUTDATA[i] << 5) & 0x80);         //二次電 空調
        
        RoomDATA[(i * 4) + 2] = (indata[i] >> 4) & 0x02;                                    //kb
        RoomDATA[(i * 4) + 2] |= ((RoomDATA[(i * 4) + 2] << 1) & 0x04);                     //kh         
        RoomDATA[(i * 4) + 2] |= ((OUTDATA[i] >> 5) & 0x01) | ((OUTDATA[i] << 1) & 0x80);   //二次電 空調
   
    #ifdef PrivacyCleaning
        RoomDATA[i * 4 + 1] &= 0xFC;
        RoomDATA[i * 4 + 1] |= ((indata[i] >> 2) & 0x03);                                   //打掃 物擾       
        RoomDATA[(i * 4) + 3] &= 0xFC;
        RoomDATA[(i * 4) + 3] |= ((indata[i] >> 6) & 0x03);                                 //打掃 物擾
    #else 
        RoomDATA[i * 4] |= (((indata[i] << 4) & 0x40) | ((indata[i] << 1) & 0x10));         //一氧化碳 防盜1       
        RoomDATA[(i * 4) + 2] |= ((indata[i] & 0x40) | ((indata[i] >> 3) & 0x10));          //一氧化碳 防盜1
    #endif       
#else 
        RoomDATA[i * 4] = indata[i] & 0x02;                                                 //kb
        RoomDATA[i * 4] |= ((indata[i] << 2) & 0x04);                                       //kh
        RoomDATA[i * 4] |= ((OUTDATA[i] >> 1) & 0x01) | ((OUTDATA[i] << 5) & 0x80);         //二次電 空調
        
        RoomDATA[(i * 4) + 2] = (indata[i] >> 4) & 0x02;                                    //kb
        RoomDATA[(i * 4) + 2] |= ((indata[i] >> 2) & 0x04);                                 //kh 
        RoomDATA[(i * 4) + 2] |= ((OUTDATA[i] >> 5) & 0x01) | ((OUTDATA[i] << 1) & 0x80);   //二次電 空調

    #ifdef PrivacyCleaning
        RoomDATA[i * 4 + 1] &= 0xFC;
        RoomDATA[i * 4 + 1] |= ((indata[i] >> 2) & 0x03);                                   //打掃 物擾       
        RoomDATA[(i * 4) + 3] &= 0xFC;
        RoomDATA[(i * 4) + 3] |= ((indata[i] >> 6) & 0x03);                                 //打掃 物擾
    #else 
        RoomDATA[i * 4] |= (((indata[i] << 4) & 0x40) | ((indata[i] << 1) & 0x10));         //一氧化碳 防盜1       
        RoomDATA[(i * 4) + 2] |= ((indata[i] & 0x40) | ((indata[i] >> 3) & 0x10));          //一氧化碳 防盜1
    #endif
#endif
    } 
//    Serial.println("--------");
    for (int i = 0; i < 6; i++)
    {
        OUTDATA[i] &= 0xEE; 
//        OUTDATA[i] |= ((PCDATA[(i*4) +1] << 3) & 0x08) | ((PCDATA[(i*4) +1] >> 1) & 0x01);
//        OUTDATA[i] |= ((PCDATA[(i*4) +3] << 7) & 0x80) | ((PCDATA[(i*4) +3] << 3) & 0x10);
        OUTDATA[i] |= ((PCDATA[(i*4) +1] >> 1) & 0x01);                                    //bit1
        OUTDATA[i] |= ((PCDATA[(i*4) +3] << 3) & 0x10);                                    //bit1
//        Serial.println(OUTDATA[i],HEX);
    }    
//    Serial.println("--------");
}
void RS485IN(void)
{
    Rs485ERR = 0;    
    byte incomingByte = 0;
    incomingByte = mySerial.read();
    //Serial.println(incomingByte,HEX);
    switch(Rs485SP){
    case 0:
        if(incomingByte == 0x48){
            Rs485SP++;
        }
        break;  
    case 1:
        if(incomingByte == 0x44){
            Rs485SP++; 
        }
        else
            Rs485SP = 0;                    
        break;  
    case 2:
        if(incomingByte == 0){
            Rs485SP++; 
        }
        else
            Rs485SP = 0;  
        incomCS = 0;    
        break;  
    case 3:
        if(incomingByte == ID)
            Rs485SP++; 
        else
            Rs485SP = 0;  
        incomCS ^= ID;
        // Serial.println(incomingByte,HEX);    
        break;  
    case 4:
        if(incomingByte == 0x06)
            Rs485SP++; 
        else
            Rs485SP = 0;  
        incomCS ^= 0x06;
            //Serial.println(incomingByte,HEX);    
        break;  
    case 29:
        if(incomingByte == incomCS){
            Rs485SP++; 
        }
        else{
            Rs485SP = 0; 
        }            
        break;  
    case 30:
        if(incomingByte == 0x45)
            Rs485SP++; 
        else
            Rs485SP = 0;      
        break;  
    case 31:
        if(incomingByte == 0x44)
            Rs485SP++; 
        else
            Rs485SP = 0;      
        break;  
    case 32:
        if(incomingByte == 0x0D){
            Rs485SP = 0; 
           // Serial.println("485 in OK");
            delayMicroseconds(750);
            RS485OUT();
            for(int k = 0; k < 12; k++){
                if ((PCDATA[k * 2] != pcdata[k * 2]) || (PCDATA[(k * 2) + 1] != pcdata[(k * 2) + 1])){
                    ROOM |= 0x0001 << k;
                 //   Serial.println(PCDATA[k * 2],HEX); 
                };
                PCDATA[k * 2] = pcdata[k * 2];    
                PCDATA[(k * 2) + 1] = pcdata[(k * 2) + 1];  
/*                Serial.print("PCDATA   0x");
                Serial.println(PCDATA[k * 2],HEX); 
                Serial.print("pcdata   0x");
                Serial.println(pcdata[k * 2],HEX);
                */
            }
            if  (ROOM > 0){
                Process();
            }
        }
        else
            Rs485SP = 0;      
        break;  
    case 5 ... 28:
        pcdata[Rs485SP - 5] = incomingByte;
        incomCS ^= incomingByte;
        Rs485SP++;
        break;
    default:
        Rs485SP = 0;
        break;
    }  
}
/*
int myuart_rx(void)        //判斷RS-485是否有資料進來
{
  for  (int i = 0; i <= 140; i++)
  {
    if (mySerial.available() > 0 )
    {
      return 1;
    }  
    delayMicroseconds(15);
  }
  return 0;  
} 
*/
void RS485OUT(void)        //房間資料傳PC
{
    byte  outcomCS;
    digitalWrite(rs485com,HIGH);
    mySerial.print(char(0x48));
    mySerial.print(char(0x44));
    mySerial.print(char(ID));
    outcomCS = ID;
    mySerial.print(char(0x00));
    mySerial.print(char(0x12));
    outcomCS ^= 0x12;
    for(int x = 0; x < 24; x++)
    {
        mySerial.print(char(RoomDATA[x]));
        outcomCS ^= RoomDATA[x];
    }  
    mySerial.print(char(outcomCS));
    mySerial.print(char(0x45));
    mySerial.print(char(0x44));
    mySerial.print(char(0x0D));
    digitalWrite(rs485com,LOW);  
}  
